/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package electro.entities;

import java.util.Comparator;

/**
 * Compares two users according to their peak consumption values
 * @author Andrea Zambon
 */
public class UsersPeakConsumptionReverseComparator implements Comparator {

    /**
     * Compares the peak consumption of two users
     *
     * @param o1 A PowerUser object representing the first user to compare
     *
     * @param o2 A PowerUser object representing the second user to compare
     *
     * @return -1 if the first user has a greater peak power consumption than the
     * second, 0 if they are equal and 1 otherwise (this is a reverse comparator)
     *
     * This method performs a reverse comparison between the peak consumptions
     * of two users.
     */
    public int compare(Object o1, Object o2) {

        //Convert to two PowerUser objects
        float max1 = ((PowerUser)o1).getMaxConsumption();
        float max2 = ((PowerUser)o2).getMaxConsumption();

        //Remember that this is a reverse comparator, so the 1 and -1 values are
        //swapped
        if (max1 > max2) {

            return -1;
        }
        else {

            if (max1 < max2) {

                return 1;
            }
            else {

                return 0;
            }
        }
    }
}
