/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package electro.entities;

import java.util.Comparator;

/**
 * Reverse comparator according to the upper bound of two values
 * @author Andrea Zambon
 */
public class ValueReverseComparator implements Comparator {

    /**
     * Compares the upper bounds of two values
     * 
     * @param o1 The first Value object to compare
     * 
     * @param o2 The second Value object to compare
     * 
     * @return -1 if the upper bound of the second Value is smaller than that of
     * the first, 0 if they are equal and 1 otherwise (this is a reverse comparator)
     * 
     * This method compares the upper bounds of the two Value objects. It is a
     * reverse comparator, so the output is reversed, returning 1 if the first
     * value is smaller, 0 if they are equal and -1 if the second is smaller.
     */
    public int compare(Object o1, Object o2) {

        Value v1 = (Value)o1;
        Value v2 = (Value)o2;

        if (v1.ub < v2.ub) {

            return 1;
        }
        else {

            if (v1.ub > v2.ub) {

                return -1;
            }
            else {

                return 0;
            }
        }
    }
}
