/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package electro.file;

import java.io.File;
import javax.swing.filechooser.FileFilter;

/**
 * This object is used to filter the files shown in the file chooser
 * dialog box. It is designed to only show .csv files.
 *
 * @author Andrea Zambon
 */
public class CSVFileFilter extends FileFilter {

    /**
     * Accepts or rejects a file
     *
     * @param f The file to test
     *
     * @return true if the file should be present in the dialog box, false
     * otherwise
     *
     * This method tests whether a file should be shown in the file chooser
     * dialog box.
     */
    @Override
    public boolean accept(File f) {

        //Show directories (for navigation) and files with .csv extension
        return f.isDirectory() ||
                (f.isFile() && (f.getName().toLowerCase().endsWith(".csv")));
    }

    /**
     * Provides the description for this file filter
     * 
     * @return The string to be shown as the file filter in the file chooser
     * dialog box
     *
     * This method returns the string to be displayed as a description for the
     * file filter applied to the file chooser dialog box.
     */
    @Override
    public String getDescription() {

        //Return a constant string
        return ".CSV (Comma separated values)";
    }
}
