/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * ColorLegend.java
 *
 * Created on 2-feb-2011, 16.14.03
 */

package electro.view;

import electro.entities.PowerUser;
import java.util.ArrayList;
import javax.swing.BoxLayout;

/**
 * This class implements the color legend window
 *
 * @author Andrea Zambon
 */
public class ColorLegend extends javax.swing.JFrame {

    /**
     * Constructor for the ColorLegend class. Creates a new window and
     * displays it.
     *
     * @param users The array of users whose colors are to be displayed
     *
     * This constructor creates a new ColorLegend window for the supplied users
     * array.
     */
    public ColorLegend(ArrayList<PowerUser> users) {

        //Initialize all the components created by the layout editor
        initComponents();

        //Set a layout to generate a single column of items
        panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));

        //Create all the items in the column
        for (int i = 0; i < users.size(); ++i) {

            //Create a new item for the current user
            ColorLegendItem item = new ColorLegendItem(this, users.get(i));

            //Add the new item to the window
            panel.add(item);
        }

        //Show the window
        setVisible(true);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        colorLegendScrollPanel = new javax.swing.JScrollPane();
        panel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        closeButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Display and change the color of each user");

        javax.swing.GroupLayout panelLayout = new javax.swing.GroupLayout(panel);
        panel.setLayout(panelLayout);
        panelLayout.setHorizontalGroup(
            panelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 454, Short.MAX_VALUE)
        );
        panelLayout.setVerticalGroup(
            panelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 210, Short.MAX_VALUE)
        );

        colorLegendScrollPanel.setViewportView(panel);

        jLabel1.setText("Click on the button showing the id of a user to change that color");

        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(closeButton, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(colorLegendScrollPanel, javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(colorLegendScrollPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 212, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(closeButton)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Handles an event to the close button
     *
     * @param evt The event that happened to the close button. This event is not
     * actually read, so all events are treated as a left click.
     *
     * This method handles clicks on the close button of the color legend window.
     * It ides the window, destroys it and returns.
     */
    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed

        //Hide the window
        setVisible(false);

        //Destroy the window
        dispose();
    }//GEN-LAST:event_closeButtonActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JScrollPane colorLegendScrollPanel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel panel;
    // End of variables declaration//GEN-END:variables
}
