/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * ColorLegendItem.java
 *
 * Created on 2-feb-2011, 16.17.00
 */

package electro.view;

import electro.entities.PowerUser;
import java.awt.Color;
import javax.swing.JColorChooser;
import javax.swing.JFrame;

/**
 * This class represents a single item in the legend window
 *
 * @author Andrea Zambon
 */
public class ColorLegendItem extends javax.swing.JPanel {

    private PowerUser u;
    private JFrame parent;

    /**
     * Constructor. Creates a new ColorLegenmdItem object.
     *
     * @param parent The parent frame of this item
     *
     * @param u The user whose data and color is to be displayed by this item.
     *
     * This constructor creates a new ColorLegendItem object containing data for
     * the specified user and into the specified parent frame.
     */
    public ColorLegendItem(JFrame parent, PowerUser u) {

        //Initialize the components created by the layout editor
        initComponents();

        //Save the parameters into this object. Perform only a shallow copy
        this.u = u;
        this.parent = parent;

        //Set the text of the button
        changeColorButton.setText("User " + u.getUserId());

        //Set the background color of the panel next to the button to match the
        //color assigned to this user.
        colorPanel.setBackground(u.getColor());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        changeColorButton = new javax.swing.JButton();
        colorPanel = new javax.swing.JPanel();

        changeColorButton.setText("User id");
        changeColorButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                changeColorButtonActionPerformed(evt);
            }
        });

        colorPanel.setBackground(new java.awt.Color(237, 128, 19));
        colorPanel.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        colorPanel.setPreferredSize(new java.awt.Dimension(60, 60));

        javax.swing.GroupLayout colorPanelLayout = new javax.swing.GroupLayout(colorPanel);
        colorPanel.setLayout(colorPanelLayout);
        colorPanelLayout.setHorizontalGroup(
            colorPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 54, Short.MAX_VALUE)
        );
        colorPanelLayout.setVerticalGroup(
            colorPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 54, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(changeColorButton, javax.swing.GroupLayout.DEFAULT_SIZE, 79, Short.MAX_VALUE)
                .addGap(19, 19, 19)
                .addComponent(colorPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(colorPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(changeColorButton, javax.swing.GroupLayout.PREFERRED_SIZE, 60, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Handles an event on the button contained in this item
     *
     * @param evt The event that happened to this button. This is not actually
     * read, so any event is treated as a left click.
     *
     * This method is called when a click is performed on the button contained
     * in this ColorLegendItem. It displays a color chooser initially set to the
     * color used to represent this user.
     */
    private void changeColorButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_changeColorButtonActionPerformed

        //Create a color chooser initially set to the color of this user
        Color newColor = JColorChooser.showDialog(parent,
                "Choose new color for user " + u.getUserId(), u.getColor());

        //Save the new color if one was selected
        if (newColor != null) {

            //Save the color in the user
            u.setColor(newColor);

            //Update the color panel for this user
            colorPanel.setBackground(newColor);

            //Redraw
            parent.validate();
            parent.repaint();
        }
    }//GEN-LAST:event_changeColorButtonActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton changeColorButton;
    private javax.swing.JPanel colorPanel;
    // End of variables declaration//GEN-END:variables
}
